DiscreteFilesClassLoader (jEdit API Documentation)
Date: 2017-03-18

org.gjt.sp.jedit.bsh.classpath

## Class DiscreteFilesClassLoader

- java.lang.Object
- - java.lang.ClassLoader
  - - java.security.SecureClassLoader
    - - java.net.URLClassLoader
      - - org.gjt.sp.jedit.bsh.classpath.BshClassLoader
        - - org.gjt.sp.jedit.bsh.classpath.DiscreteFilesClassLoader

- All Implemented Interfaces:
    java.io.Closeable, java.lang.AutoCloseable

      public class DiscreteFilesClassLoader
      extends BshClassLoader

  A classloader which can load one or more classes from specified sources. Because the classes are loaded via a single classloader they change as a group and any versioning cross dependencies can be managed.

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `DiscreteFilesClassLoader.ClassSourceMap`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `DiscreteFilesClassLoader(BshClassManager classManager, DiscreteFilesClassLoader.ClassSourceMap map)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `java.lang.Class` | `findClass(java.lang.String name)` Find the correct source for the class...
    `java.lang.String` | `toString()`

    - ### Methods inherited from class org.gjt.sp.jedit.bsh.classpath.BshClassLoader

      `addURL, loadClass`

    - ### Methods inherited from class java.net.URLClassLoader

      `close, definePackage, findResource, findResources, getPermissions, getResourceAsStream, getURLs, newInstance, newInstance`

    - ### Methods inherited from class java.security.SecureClassLoader

      `defineClass, defineClass`

    - ### Methods inherited from class java.lang.ClassLoader

      `clearAssertionStatus, defineClass, defineClass, defineClass, defineClass, definePackage, findLibrary, findLoadedClass, findSystemClass, getClassLoadingLock, getPackage, getPackages, getParent, getResource, getResources, getSystemClassLoader, getSystemResource, getSystemResourceAsStream, getSystemResources, loadClass, registerAsParallelCapable, resolveClass, setClassAssertionStatus, setDefaultAssertionStatus, setPackageAssertionStatus, setSigners`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### DiscreteFilesClassLoader

          public DiscreteFilesClassLoader(BshClassManager classManager,
                                          DiscreteFilesClassLoader.ClassSourceMap map)

  - ### Method Detail

    - #### findClass

          public java.lang.Class findClass(java.lang.String name)
                                    throws java.lang.ClassNotFoundException

      Description copied from class: `BshClassLoader`
      Find the correct source for the class... Try designated loader if any Try our URLClassLoader paths if any Try base loader if any Try system ???
      Overrides:
        `findClass` in class `BshClassLoader`
      Throws:
        `java.lang.ClassNotFoundException`

    - #### toString

          public java.lang.String toString()

      Overrides:
        `toString` in class `java.lang.Object`